/*
 * HelpWindow.java
 *
 * Created on March 8, 2007, 9:46 AM
 *
GeoShear - A program to explore deformation of cross sections of stone
    
Copyright (C) September 2007, Chris Warren (Chris.Warren@williams.edu) and 
Paul Karabinos (Paul.M.Karabinos@williams.edu)

This program is licensed under the terms of the Williams College Software 
License as published by Williams College; either version 1 of the License, or 
(at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
PARTICULAR PURPOSE. See the Williams College Software License for more details.

You should have received a copy of the Williams College Software License along 
with this program; if not, write to Williams College Office for Information 
Technology, 22 Lab Campus Drive, Williamstown, MA 01267 USA
 *
 */

package edu.williams.geoshear;

/**
 * This is a simple window to display the help text for the GeoShear program. 
 * Ideally this text would be read in from a separate file, but for now it's just
 * hard coded in here.
 * @author cwarren
 */
public class HelpWindow extends javax.swing.JFrame
{
    
    /** Creates new form HelpWindow */
    public HelpWindow ()
    {
        initComponents ();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        HelpScroll = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        CloseButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();

        jTextArea1.setColumns(20);
        jTextArea1.setEditable(false);
        jTextArea1.setFont(new java.awt.Font("Tahoma", 0, 12));
        jTextArea1.setLineWrap(true);
        jTextArea1.setRows(5);
        jTextArea1.setText("GeoShear is a program that simulates two dimensional deformation of elliptical objects.\n\nThe display area is on the left. All the controls that let you interact with the display are on the right.\n\n--------------------------------------------\n\nDISPLAY AREA\n\nThis is the large, 700 by 700 pixels, square area on the left where the elliptical objects and optional background are displayed. When there is no background image it shows a reference ellipse and x- and y-axis lines.\t\n\n--------------------------------------------\n\nDISPLAY CONTROLS\n\nThis is the rectangular area on the right. The function of each control button is described below. In general, the first controls you will need when you open the program are near the top and the last controls you will need when finished are near the bottom.\n\nLoad Ellipse File- Loads an existing ellipse data file that contains shape, orientation position, and color information. Such files must have a \u2018.ges\u2019 or \u2018.txt\u2019 suffix. A sample file called Random_Ellipses.txt is bundled with the program.\n\nHelp- Displays the help window.\n\nAbout- Displays information about this program and its licensing.\n\n-----------\n\nDisplay Editor- Allows you to edit the display, and takes you out of editing mode by clicking a second time. This allows you to draw elliptical objects with the mouse, load a background image, and trace ellipses from a background image. Clicking the Display Editor also removes all deformation, zoom, and centering changes previously made in the display. It does not change pebble axes, pebble fill, or background display options. \n\nPebbles are created by dragging the mouse in the display area to define the long axis and then the short axis. \n1. Start dragging (press the left mouse button and move the mouse) to define the long axis.\n2. Hit the space bar to set the long axis (keep the mouse button pressed). \n3. Continue dragging (roughly perpendicular to the original direction) to define the short axis.\n4. Hit the space bar again to set the short axis. Release the mouse button.\n5. A dialog box will then prompt you to either keep the new pebble or discard it. You can accept the pebble by clicking \u2018yes\u2019 in the prompt, hitting \u2018Enter\u201d, or pressing the space bar.\n\nNOTE: Pebbles must have a minimum long axis length of 24 pixels - if you try to set the long axis to less than that the pebble won't be created! \n\nSelecting Pebbles- All pebbles in the display have a white circle in their center. Click (without dragging) in this circle to select a pebble (select multiple pebbles by holding down CTL while clicking). CTL+a selects all the pebbles. Selected pebbles may then be deleted by hitting the delete or backspace key.  Unselect the pebbles by clicking any other part of the display. Selected pebbles remain selected even when you exit the editing mode, and they will be highlighted in plots. On the big Rf vs. \uf046 and Polar plots you have the option to display information about the plot points for selected pebbles.\n\nLoad Background- Loads an image background for tracing elliptical objects. Display Editor must be on to load a background. The display area is 700 by 700 pixels and only the upper left region of a larger image will be visible in the display. To avoid cropping, you must re-size a larger image in another program before loading it as a background. NOTE: By using the Background checkbox you can alternately hide and show the backgrounds. A sample background image called Conglomerate.png is bundled with the program.\n\nPebble Color- The colored box shows what color new pebbles will be. Double-click on the box to change the color. You can change the color of all selected pebbles by ALT-clicking on the color box.\n\n-----------\n\nDISPLAY OPTIONS\n\nThese controls affect how the display appears but do not change the underlying data.\n\nPebble Axes- Checking the box toggles between showing and hiding long and short axes of elliptical objects.\n\nFill Pebbles- Checking the box toggles between filled and outlined pebbles.\n\nBackground- Checking the box toggles between showing and hiding the loaded background. NOTE: when the background is not present or not displayed a reference ellipse and axes are shown.\n\nZoom- The slider lets you change the magnification of the cross section from 20% to 500%. \n\nReset- Removes all deformation, positioning, and magnification changes.\n\nRe-Center Display- Re-centers the display but preserves deformation. The display may be moved off center by holding down the ALT key and dragging in the display area.\n\nUn-Zoom- Returns display to the default magnification of 100%.\n\n-----------\n\nDEFORMATION TYPE\n\nThe program lets you perform three linear transformations or simulated deformations: simple shear, pure shear, and rotation. You can either click and drag in the display or specify the amount and direction of deformation.\n\nSimple shear- Clicking this radio button constrains deformation to be by simple shear. Click and drag in the display to deform elliptical objects. You can also type in exact values for simple shear in the horizontal and/or vertical directions in the rectangles below the radio button. When the cursor is in the text box the up and down keys will change the shear amount by .01 per key press. Of course, area is always preserved by simple shear. The gray reference circle helps keep track of the deformation. \n\nPure shear- Clicking this radio button constrains deformation to be by pure shear. Click and drag in the display to deform elliptical objects. You can also type in exact values for extension in the horizontal and vertical directions in the rectangles below the radio button. When the cursor is in the text box the up and down keys will change the shear amount by .01 per key press. The gray reference circle helps keep track of the deformation. Pure shear deformation does not necessarily preserve area, so three options are available:\n\nArea Not Preserved (click to change)- This button toggles between three options. The first allows area to change during pure shear. Area Preserved, Y Ind. Var.- lets you specify the vertical extension and adjusts horizontal extension to preserve area. Area Preserved, X Ind. Var.- lets you specify the horizontal extension and adjusts vertical extension to preserve area.\n\nRotation- Clicking this radio button constrains deformation to be by rotation. Click and drag in the display to rotate objects. You can also type in exact rotation angles as either degree or radians. When the cursor is in the text box the up and down keys will change the rotation amount by 1 degree or .01 radians per key press.\n\nNotes about dragging in the display area- If you hold down the ALT key while dragging you can move the display without deforming objects. This is useful when deformation squeezes objects outside of the field of view. Holding the CTL key while dragging constrains deformation to the horizontal direction. Holding the SHIFT key while dragging constrains deformation to the vertical direction. In all cases the key must be pressed before you start dragging!\n\n-----------\n\nPLOTS\n\nA small graph of Rf vs. \uf046 is always displayed in the control area. Points in the plot are colored the same as their corresponding pebbles. The x-axis is linear and adjusts scale automatically to include all objects in the display.\n\nBig Cartesian Plot- A larger Cartesian Rf vs. \uf046 plot opens up in a new, re-sizeable window if this button is pressed. The Big Plot window is always topmost; to see the display under it you must minimize this window. The big plot has a number of options. You can switch the scale between linear and natural log, and you can manually set the maximum X value. Clicking the Pebble Info button in the Big Plot will display information for pebbles previously selected in the display (see Display Editor for instructions on selecting pebbles). Another way to get information on individual points is to click on the plot and the Rf and \uf046 values for that point will be displayed in the lower right of the window. The camera button at the lower right of the window lets you save a snapshot of the current plot as a PNG, BMP, or JPG file. The latter may show some distortions from the compression algorithm; for best size vs. quality use PNG format. \n\nBig Polar Plot- A polar plot of ln(Rf) vs. 2(\uf046) opens up in a new, re-sizeable window if this button is pressed. This plot has certain advantages over the Cartesian plot as discussed by Elliott (1970). The polar plot window is always topmost; to see the display under it you must minimize this window. The camera button at the lower right of the window lets you save a snapshot of the current big plot (which sometimes take a couple of seconds to update itself, so wait a moment after deforming the display before taking the snapshot) as a PNG, BMP, or JPG file. The latter may show some distortions from the compression algorithm; for best size vs. quality use PNG format. To get information about individual points, click on the plot and the ln(Rf) and 2(\uf046) values for that point are displayed in the lower right of the window.\n\n-----------\n\nFILE COMMANDS\n\nThese commands let you save displays and convert the pebble information to data files for a variety of purposes. \n\nSave to ges.- This lets you save the starting display to a file. The file retains the background and all the elliptical objects, but not subsequent deformation or other display changes. The file must end with the suffix \u2018.txt\u2019 or \u2018.ges\u2019.\n\nSave Deformed- This lets you save a deformed display, that is, it saves the elliptical objects after the simulated deformation, but not the original shapes. The file must end with the suffix \u2018.txt\u2019 or \u2018.ges\u2019.\n\nExport to tab.- This saves the undeformed pebble information to a tab-delimited file, from which it can easily be read by a variety of other programs (e.g. Excel) and then used to analyze the data. The file must end with the suffix \u2018.txt\u2019 or \u2018.tab\u2019.\n\nExport Deformed- This saves the deformed pebble information to a tab-delimited file, from which it can easily be read by a variety of other programs (e.g. Excel) and then used to analyze the data. The file must end with the suffix \u2018.txt\u2019 or \u2018.tab\u2019.\n\nNote: The file format is plain text (can end in .txt or .ges), so you can create or modify them in any text editor you like. A spreadsheet program such as Excel can also be used to create a display file from tabular data. See the bundled spreadsheet, PebbleFileBuilder.xls, for details on this aspect of this program. Also, see the sample file, Random_Ellipses.txt.\n\nCamera- The button with the camera icon lets you take a snapshot of the current display. It will capture whatever is in the display area as a PNG, BMP, or JPG image. The latter is compressed and so may have distortions. To optimize quality and file size use PNG format.\n\nExit- Exits the program without saving anything.\n\n-----------\n\nStrain Ellipse Info- This area displays information about the strain ellipse (the grey circle in the center that you can see when no background is displayed).\n\n");
        jTextArea1.setWrapStyleWord(true);
        jTextArea1.setAutoscrolls(false);
        HelpScroll.setViewportView(jTextArea1);

        CloseButton.setText("Close");
        CloseButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                CloseButtonActionPerformed(evt);
            }
        });

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 18));
        jLabel1.setText("GeoShear Help");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(291, 291, 291)
                        .add(CloseButton))
                    .add(layout.createSequentialGroup()
                        .add(251, 251, 251)
                        .add(jLabel1))
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(HelpScroll, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 629, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(HelpScroll, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 530, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(CloseButton)
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void CloseButtonActionPerformed (java.awt.event.ActionEvent evt)//GEN-FIRST:event_CloseButtonActionPerformed
    {//GEN-HEADEREND:event_CloseButtonActionPerformed
// TODO add your handling code here:
        this.setVisible (false);
    }//GEN-LAST:event_CloseButtonActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main (String args[])
    {
        java.awt.EventQueue.invokeLater (new Runnable ()
        {
            public void run ()
            {
                new HelpWindow ().setVisible (true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton CloseButton;
    private javax.swing.JScrollPane HelpScroll;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JTextArea jTextArea1;
    // End of variables declaration//GEN-END:variables
    
}
