/*
 * Main.java
 *
 * Created on March 7, 2007, 4:01 PM
 *
GeoShear - A program to explore deformation of cross sections of stone
    
Copyright (C) September 2007, Chris Warren (Chris.Warren@williams.edu) and 
Paul Karabinos (Paul.M.Karabinos@williams.edu)

This program is licensed under the terms of the Williams College Software 
License as published by Williams College; either version 1 of the License, or 
(at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
PARTICULAR PURPOSE. See the Williams College Software License for more details.

You should have received a copy of the Williams College Software License along 
with this program; if not, write to Williams College Office for Information 
Technology, 22 Lab Campus Drive, Williamstown, MA 01267 USA
 *
 */



package edu.williams.geoshear;

import javax.swing.*;          
import java.awt.*;
import java.awt.event.*;

/**
 * GeoShear is an application to simulate simple, pure, and rotational shear on
 * cross-sections of rock. Users create or load sets of ellipsoids which are then
 * deformed by mouse action or entering specific values. As the deformation takes
 * place RF-Phi plots of those ellipsoids are updated in realtime.
 * @author programming by Chris Warren
 * @author subject matter expertise by Paul Karabinos
 * @version 1.0
 */
public class Main {

    /** Creates a new instance of Main */
    public Main() {}

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try 
        {
            //UIManager.setLookAndFeel (UIManager.getSystemLookAndFeelClassName ());
            UIManager.setLookAndFeel (UIManager.getCrossPlatformLookAndFeelClassName ());
        } catch (UnsupportedLookAndFeelException e) 
        {
        } catch (ClassNotFoundException e) 
        {
        } catch (InstantiationException e) 
        {
        } catch (IllegalAccessException e) 
        {
        }
        MainWindow app = new MainWindow();
        app.setVisible(true);
    }
}


//~ Formatted by Jindent --- http://www.jindent.com
